summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
Diffstat (limited to 'app-editors/gvim')
-rw-r--r--app-editors/gvim/Manifest6
-rw-r--r--app-editors/gvim/gvim-9.0.2167.ebuild (renamed from app-editors/gvim/gvim-8.2.0814-r100.ebuild)177
-rw-r--r--app-editors/gvim/gvim-9.1.0366.ebuild365
-rw-r--r--app-editors/gvim/gvim-9.1.0470.ebuild365
-rw-r--r--app-editors/gvim/gvim-9999.ebuild177
-rw-r--r--app-editors/gvim/metadata.xml12
6 files changed, 908 insertions, 194 deletions
diff --git a/app-editors/gvim/Manifest b/app-editors/gvim/Manifest
index 9f17c290c490..67344428f5b6 100644
--- a/app-editors/gvim/Manifest
+++ b/app-editors/gvim/Manifest
@@ -1,2 +1,4 @@
-DIST vim-8.2.0360-gentoo-patches.tar.xz 2612 BLAKE2B a9273a686b31dd873b25bfc07f7bc254f11038bde275ae4e6f56513a14e0268fdc1032ae847d1d7f8539f8a657217011770ccb4685998f34722383ec7bfb1a15 SHA512 00bc8eb8b20a4a6f3bbd179bb90d42fa6727c8eaae5b625e95e52c33638d456ef36d06b51c542ecaffb237c0b4f7aa72dc3bae7fe00144d55ab0d2fa51950f3b
-DIST vim-8.2.0814.tar.gz 14953478 BLAKE2B fd4155ec749bd9a705e8114ff7f8cc321182c9286733ff2f665e265ec0af830f9e70c730b8d0215f6db1f73a8e2f878d22932a72c8dbfe921591be7adcdaab00 SHA512 4ddd9e2d30719f931cadd1a4de5700736f641f4b074378d9ea1462a90b81975ce8e8c3ca2e3a1e15ac0288824eef5b0f0a3e31482f7637c450c6d7e52c8f40d2
+DIST vim-9.0.2092-patches.tar.xz 2640 BLAKE2B 3a4b2bc57712de3b92b0e8d9b2d428e4d576665a183927051eddd53d019a5ca413c74dc10aff09917ee3120bd2e2ba441219d7238994f0d5ba14fc9c31180199 SHA512 ec27e4056460948ff86bc48a21de239a84b53757a8283144ec121654096796d970ad832234d6591a132bcd38bc12dc507cc7795a11cd383d20f08b4d9bcb051f
+DIST vim-9.0.2167.tar.gz 17405049 BLAKE2B 496c8f9672bc4ecce743a145bc2b671bf09034b2875e728406b318c8b12e2d8d4ee3423ce94f8749679f07d36f229954f7ef0b12ce7bc4d71ccf6637ce2d6029 SHA512 6a9a785b1915dc167210b0da4d5e4401c71ee49b3554c8a22566378658ddcc3493562897ea39035852399cc5ffb55a73355ab13390c27a4d00ffd76bcd10ddf0
+DIST vim-9.1.0366.tar.gz 17861209 BLAKE2B 8771f5ef6a966c1b5992a437dd6cf1de9525458f61a4cd8fa53737a7bde29a4da101668639a301288a266ee8b3911857d1ba5b4e88870b60473eb1eaa608d7a5 SHA512 11be2a6e349c7b6d26fc1943c35ea18c662baa4f30ae76936eefb30e0b4d988bfcaedf7ecd2c3903f64e23c75957f55b9bb4073e0f38c7eb10ef0ee0dc652ddb
+DIST vim-9.1.0470.tar.gz 17919981 BLAKE2B 90ebffc6e7b6162f8a047976659e044b75aaa946799b901e9f8c88f04a787543cde56545c8c6e5394fa2bc957d2e46810c5ca3f1315fc20a398a57bbdbc90f4c SHA512 41b71e9e5385237b30aa256f064c9d5c914b29a97c0ec562f1995ac5d476fcf840c3f0e9a52e599f6084777db147e83fcbf0ec6b985bb94c126264d4cbafb964
diff --git a/app-editors/gvim/gvim-8.2.0814-r100.ebuild b/app-editors/gvim/gvim-9.0.2167.ebuild
index 249f42765281..20fcedbb1b9e 100644
--- a/app-editors/gvim/gvim-8.2.0814-r100.ebuild
+++ b/app-editors/gvim/gvim-9.0.2167.ebuild
@@ -1,14 +1,19 @@
-# Copyright 1999-2021 Gentoo Authors
+# Copyright 1999-2024 Gentoo Authors
# Distributed under the terms of the GNU General Public License v2
-EAPI=7
-VIM_VERSION="8.2"
-LUA_COMPAT=( lua5-1 luajit )
-PYTHON_COMPAT=( python3_{7..10} )
+EAPI=8
+
+# Please bump with app-editors/vim-core and app-editors/vim
+
+VIM_VERSION="9.0"
+VIM_PATCHES_VERSION="9.0.2092"
+
+LUA_COMPAT=( lua5-{1..4} luajit )
+PYTHON_COMPAT=( python3_{10..12} )
PYTHON_REQ_USE="threads(+)"
-USE_RUBY="ruby24 ruby25 ruby26 ruby27"
+USE_RUBY="ruby31 ruby32"
-inherit vim-doc flag-o-matic xdg-utils bash-completion-r1 prefix lua-single python-single-r1 ruby-single
+inherit bash-completion-r1 flag-o-matic lua-single prefix python-single-r1 ruby-single toolchain-funcs vim-doc xdg-utils
if [[ ${PV} == 9999* ]]; then
inherit git-r3
@@ -16,19 +21,21 @@ if [[ ${PV} == 9999* ]]; then
EGIT_CHECKOUT_DIR=${WORKDIR}/vim-${PV}
else
SRC_URI="https://github.com/vim/vim/archive/v${PV}.tar.gz -> vim-${PV}.tar.gz
- https://dev.gentoo.org/~zlogene/distfiles/app-editors/vim/vim-8.2.0360-gentoo-patches.tar.xz"
- KEYWORDS="~alpha amd64 arm arm64 ~hppa ~ia64 ppc ppc64 ~s390 sparc x86 ~amd64-linux ~x86-linux ~ppc-macos ~x86-solaris"
+ https://git.sr.ht/~xxc3nsoredxx/vim-patches/refs/download/vim-${VIM_PATCHES_VERSION}-patches/vim-${VIM_PATCHES_VERSION}-patches.tar.xz"
+ KEYWORDS="~alpha amd64 arm arm64 ~hppa ~ia64 ppc ppc64 ~riscv ~s390 sparc x86 ~amd64-linux ~x86-linux ~ppc-macos"
fi
+S="${WORKDIR}"/vim-${PV}
DESCRIPTION="GUI version of the Vim text editor"
-HOMEPAGE="https://vim.sourceforge.io/ https://github.com/vim/vim"
+HOMEPAGE="https://www.vim.org https://github.com/vim/vim"
-SLOT="0"
LICENSE="vim"
-IUSE="acl aqua cscope debug gtk gtk2 lua motif neXt netbeans nls perl python racket ruby selinux session sound tcl"
+SLOT="0"
+IUSE="acl aqua crypt cscope debug lua minimal motif netbeans nls perl python racket ruby selinux session sound tcl"
REQUIRED_USE="
lua? ( ${LUA_REQUIRED_USE} )
python? ( ${PYTHON_REQUIRED_USE} )
+ aqua? ( !motif )
"
RDEPEND="
@@ -41,24 +48,13 @@ RDEPEND="
x11-libs/libXt
acl? ( kernel_linux? ( sys-apps/acl ) )
!aqua? (
- gtk? (
+ motif? ( >=x11-libs/motif-2.3:0 )
+ !motif? (
x11-libs/gtk+:3
x11-libs/libXft
)
- !gtk? (
- gtk2? (
- >=x11-libs/gtk+-2.6:2
- x11-libs/libXft
- )
- !gtk2? (
- motif? ( >=x11-libs/motif-2.3:0 )
- !motif? (
- neXt? ( x11-libs/neXtaw )
- !neXt? ( x11-libs/libXaw )
- )
- )
- )
)
+ crypt? ( dev-libs/libsodium:= )
cscope? ( dev-util/cscope )
lua? (
${LUA_DEPS}
@@ -75,36 +71,45 @@ RDEPEND="
tcl? ( dev-lang/tcl:0= )
"
DEPEND="${RDEPEND}
- sys-devel/autoconf
+ x11-base/xorg-proto"
+# configure runs the Lua interpreter
+BDEPEND="
+ dev-build/autoconf
virtual/pkgconfig
+ lua? ( ${LUA_DEPS} )
nls? ( sys-devel/gettext )
"
-# configure runs the Lua interpreter
-BDEPEND="lua? ( ${LUA_DEPS} )"
+PDEPEND="!minimal? ( app-vim/gentoo-syntax )"
+
+if [[ ${PV} != 9999* ]]; then
+ # Gentoo patches to fix runtime issues, cross-compile errors, etc
+ PATCHES=(
+ "${WORKDIR}/vim-${VIM_PATCHES_VERSION}-patches"
+ )
+fi
# various failures (bugs #630042 and #682320)
RESTRICT="test"
-S=${WORKDIR}/vim-${PV}
+# platform-specific checks (bug #898450):
+# - acl() -- Solaris
+# - statacl() -- AIX
+QA_CONFIG_IMPL_DECL_SKIP=(
+ 'acl'
+ 'statacl'
+)
pkg_setup() {
# people with broken alphabets run into trouble. bug 82186.
unset LANG LC_ALL
export LC_COLLATE="C"
- # Gnome sandbox silliness. bug #114475.
- mkdir -p "${T}"/home || die
- export HOME="${T}"/home
-
use lua && lua-single_pkg_setup
use python && python-single-r1_pkg_setup
}
src_prepare() {
- if [[ ${PV} != 9999* ]]; then
- # Gentoo patches to fix runtime issues, cross-compile errors, etc
- eapply "${WORKDIR}"/patches/
- fi
+ default
# Fixup a script to use awk instead of nawk
sed -i -e \
@@ -113,9 +118,9 @@ src_prepare() {
# Read vimrc and gvimrc from /etc/vim
echo '#define SYS_VIMRC_FILE "'${EPREFIX}'/etc/vim/vimrc"' \
- >> "${S}"/src/feature.h || die "echo failed"
+ >> "${S}"/src/feature.h || die "echo failed"
echo '#define SYS_GVIMRC_FILE "'${EPREFIX}'/etc/vim/gvimrc"' \
- >> "${S}"/src/feature.h || die "echo failed"
+ >> "${S}"/src/feature.h || die "echo failed"
# Use exuberant ctags which installs as /usr/bin/exuberant-ctags.
# Hopefully this pattern won't break for a while at least.
@@ -128,18 +133,12 @@ src_prepare() {
"${S}"/runtime/menu.vim \
"${S}"/src/configure.ac || die 'sed failed'
- # Don't be fooled by /usr/include/libc.h. When found, vim thinks
- # this is NeXT, but it's actually just a file in dev-libs/9libs
- # This fixes bug 43885 (20 Mar 2004 agriffis)
- sed -i -e \
- 's/ libc\.h / /' "${S}"/src/configure.ac || die 'sed failed'
-
# gcc on sparc32 has this, uhm, interesting problem with detecting EOF
# correctly. To avoid some really entertaining error messages about stuff
# which isn't even in the source file being invalid, we'll do some trickery
# to make the error never occur. bug 66162 (02 October 2004 ciaranm)
find "${S}" -name '*.c' | while read c; do
- echo >> "$c" || die "echo failed"
+ echo >> "$c" || die "echo failed"
done
# Try to avoid sandbox problems. Bug #114475.
@@ -151,16 +150,29 @@ src_prepare() {
cp -v "${S}"/src/config.mk.dist "${S}"/src/auto/config.mk || die "cp failed"
- # Bug #378107 - Build properly with >=perl-core/ExtUtils-ParseXS-3.20.0
+ # Fix bug 18245: Prevent "make" from the following chain:
+ # (1) Notice configure.ac is newer than auto/configure
+ # (2) Rebuild auto/configure
+ # (3) Notice auto/configure is newer than auto/config.mk
+ # (4) Run ./configure (with wrong args) to remake auto/config.mk
sed -i -e \
- "s:\\\$(PERLLIB)/ExtUtils/xsubpp:${EPREFIX}/usr/bin/xsubpp:" \
- "${S}"/src/Makefile || die 'sed for ExtUtils-ParseXS failed'
+ 's# auto/config\.mk:#:#' src/Makefile || die "Makefile sed failed"
+ rm -v src/auto/configure || die "rm failed"
+
+ # --with-features=huge forces on cscope even if we --disable it. We need
+ # to sed this out to avoid screwiness. (1 Sep 2004 ciaranm)
+ if ! use cscope; then
+ sed -i -e \
+ '/# define FEAT_CSCOPE/d' src/feature.h || die "couldn't disable cscope"
+ fi
- eapply_user
+ # bug 908961
+ if use elibc_musl ; then
+ sed -i -e '/ja.sjis/d' src/po/Make_all.mak || die
+ fi
}
src_configure() {
- local myconf=()
# Fix bug 37354: Disallow -funroll-all-loops on amd64
# Bug 57859 suggests that we want to do this for all archs
@@ -171,14 +183,6 @@ src_configure() {
# multiple archs...
replace-flags -O3 -O2
- # Fix bug 18245: Prevent "make" from the following chain:
- # (1) Notice configure.ac is newer than auto/configure
- # (2) Rebuild auto/configure
- # (3) Notice auto/configure is newer than auto/config.mk
- # (4) Run ./configure (with wrong args) to remake auto/config.mk
- sed -i -e \
- 's# auto/config\.mk:#:#' src/Makefile || die "Makefile sed failed"
- rm -v src/auto/configure || die "rm failed"
emake -j1 -C src autoconf
# This should fix a sandbox violation (see bug 24447). The hvc
@@ -192,12 +196,13 @@ src_configure() {
use debug && append-flags "-DDEBUG"
- myconf=(
+ local myconf=(
--with-features=huge
--disable-gpm
--with-gnome=no
$(use_enable sound canberra)
$(use_enable acl)
+ $(use_enable crypt libsodium)
$(use_enable cscope)
$(use_enable netbeans)
$(use_enable nls)
@@ -211,14 +216,11 @@ src_configure() {
$(use_enable tcl tclinterp)
)
- # --with-features=huge forces on cscope even if we --disable it. We need
- # to sed this out to avoid screwiness. (1 Sep 2004 ciaranm)
- if ! use cscope; then
- sed -i -e \
- '/# define FEAT_CSCOPE/d' src/feature.h || die "couldn't disable cscope"
- fi
-
if use lua; then
+ # -DLUA_COMPAT_OPENLIB=1 is required to enable the
+ # deprecated (in 5.1) luaL_openlib API (#874690)
+ use lua_single_target_lua5-1 && append-cppflags -DLUA_COMPAT_OPENLIB=1
+
myconf+=(
--enable-luainterp
$(use_with lua_single_target_luajit luajit)
@@ -226,13 +228,7 @@ src_configure() {
)
fi
- # gvim's GUI preference order is as follows:
- # aqua CARBON (not tested)
- # -aqua gtk GTK3
- # -aqua -gtk gtk2 GTK2
- # -aqua -gtk -gtk motif MOTIF
- # -aqua -gtk -gtk -motif neXt NEXTAW
- # -aqua -gtk -gtk -motif -neXt ATHENA
+ # Default is gtk unless aqua or motif are enabled
echo ; echo
if use aqua; then
einfo "Building gvim with the Carbon GUI"
@@ -240,23 +236,13 @@ src_configure() {
--enable-darwin
--enable-gui=carbon
)
- elif use gtk; then
- myconf+=( --enable-gtk3-check )
- einfo "Building gvim with the gtk+-3 GUI"
- myconf+=( --enable-gui=gtk3 )
- elif use gtk2; then
- myconf+=( --enable-gtk2-check )
- einfo "Building gvim with the gtk+-2 GUI"
- myconf+=( --enable-gui=gtk2 )
elif use motif; then
einfo "Building gvim with the MOTIF GUI"
myconf+=( --enable-gui=motif )
- elif use neXt; then
- einfo "Building gvim with the neXtaw GUI"
- myconf+=( --enable-gui=nextaw )
else
- einfo "Building gvim with the Athena GUI"
- myconf+=( --enable-gui=athena )
+ myconf+=( --enable-gtk3-check )
+ einfo "Building gvim with the gtk+-3 GUI"
+ myconf+=( --enable-gui=gtk3 )
fi
echo ; echo
@@ -266,15 +252,16 @@ src_configure() {
# keep prefix env contained within the EPREFIX
use prefix && myconf+=( --without-local-dir )
- if [[ ${CHOST} == *-interix* ]]; then
- # avoid finding of this function, to avoid having to patch either
- # configure or the source, which would be much more hackish.
- # after all vim does it right, only interix is badly broken (again)
- export ac_cv_func_sigaction=no
+ if tc-is-cross-compiler ; then
+ export vim_cv_getcwd_broken=no \
+ vim_cv_memmove_handles_overlap=yes \
+ vim_cv_stat_ignores_slash=yes \
+ vim_cv_terminfo=yes \
+ vim_cv_toupper_broken=no
fi
econf \
- --with-modified-by=Gentoo-${PVR} \
+ --with-modified-by="Gentoo-${PVR} (RIP Bram)" \
--with-vim-name=gvim \
--with-x \
"${myconf[@]}"
@@ -314,7 +301,7 @@ src_test() {
# Call eselect vi update with --if-unset
# to respect user's choice (bug 187449)
eselect_vi_update() {
- einfo "Calling eselect vi update..."
+ ebegin "Calling eselect vi update"
eselect vi update --if-unset
eend $?
}
diff --git a/app-editors/gvim/gvim-9.1.0366.ebuild b/app-editors/gvim/gvim-9.1.0366.ebuild
new file mode 100644
index 000000000000..0b232812613b
--- /dev/null
+++ b/app-editors/gvim/gvim-9.1.0366.ebuild
@@ -0,0 +1,365 @@
+# Copyright 1999-2024 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+# Please bump with app-editors/vim-core and app-editors/vim
+
+VIM_VERSION="9.1"
+VIM_PATCHES_VERSION="9.0.2092"
+
+LUA_COMPAT=( lua5-{1..4} luajit )
+PYTHON_COMPAT=( python3_{10..12} )
+PYTHON_REQ_USE="threads(+)"
+USE_RUBY="ruby31 ruby32"
+
+inherit bash-completion-r1 flag-o-matic lua-single prefix python-single-r1 ruby-single toolchain-funcs vim-doc xdg-utils
+
+if [[ ${PV} == 9999* ]]; then
+ inherit git-r3
+ EGIT_REPO_URI="https://github.com/vim/vim.git"
+ EGIT_CHECKOUT_DIR=${WORKDIR}/vim-${PV}
+else
+ SRC_URI="https://github.com/vim/vim/archive/v${PV}.tar.gz -> vim-${PV}.tar.gz
+ https://git.sr.ht/~xxc3nsoredxx/vim-patches/refs/download/vim-${VIM_PATCHES_VERSION}-patches/vim-${VIM_PATCHES_VERSION}-patches.tar.xz"
+ KEYWORDS="~alpha amd64 arm ~arm64 ~hppa ~ia64 ~ppc ~ppc64 ~riscv ~s390 sparc x86 ~amd64-linux ~x86-linux ~ppc-macos"
+fi
+S="${WORKDIR}"/vim-${PV}
+
+DESCRIPTION="GUI version of the Vim text editor"
+HOMEPAGE="https://www.vim.org https://github.com/vim/vim"
+
+LICENSE="vim"
+SLOT="0"
+IUSE="acl aqua crypt cscope debug lua minimal motif netbeans nls perl python racket ruby selinux session sound tcl"
+REQUIRED_USE="
+ lua? ( ${LUA_REQUIRED_USE} )
+ python? ( ${PYTHON_REQUIRED_USE} )
+ aqua? ( !motif )
+"
+
+RDEPEND="
+ ~app-editors/vim-core-${PV}
+ >=app-eselect/eselect-vi-1.1
+ >=sys-libs/ncurses-5.2-r2:0=
+ x11-libs/libICE
+ x11-libs/libSM
+ x11-libs/libXext
+ x11-libs/libXt
+ acl? ( kernel_linux? ( sys-apps/acl ) )
+ !aqua? (
+ motif? ( >=x11-libs/motif-2.3:0 )
+ !motif? (
+ x11-libs/gtk+:3
+ x11-libs/libXft
+ )
+ )
+ crypt? ( dev-libs/libsodium:= )
+ cscope? ( dev-util/cscope )
+ lua? (
+ ${LUA_DEPS}
+ $(lua_gen_impl_dep 'deprecated' lua5-1)
+ )
+ nls? ( virtual/libintl )
+ perl? ( dev-lang/perl:= )
+ python? ( ${PYTHON_DEPS} )
+ racket? ( dev-scheme/racket )
+ ruby? ( ${RUBY_DEPS} )
+ selinux? ( sys-libs/libselinux )
+ session? ( x11-libs/libSM )
+ sound? ( media-libs/libcanberra )
+ tcl? ( dev-lang/tcl:0= )
+"
+DEPEND="${RDEPEND}
+ x11-base/xorg-proto"
+# configure runs the Lua interpreter
+BDEPEND="
+ dev-build/autoconf
+ virtual/pkgconfig
+ lua? ( ${LUA_DEPS} )
+ nls? ( sys-devel/gettext )
+"
+PDEPEND="!minimal? ( app-vim/gentoo-syntax )"
+
+if [[ ${PV} != 9999* ]]; then
+ # Gentoo patches to fix runtime issues, cross-compile errors, etc
+ PATCHES=(
+ "${WORKDIR}/vim-${VIM_PATCHES_VERSION}-patches"
+ )
+fi
+
+# various failures (bugs #630042 and #682320)
+RESTRICT="test"
+
+# platform-specific checks (bug #898450):
+# - acl() -- Solaris
+# - statacl() -- AIX
+QA_CONFIG_IMPL_DECL_SKIP=(
+ 'acl'
+ 'statacl'
+)
+
+pkg_setup() {
+ # people with broken alphabets run into trouble. bug 82186.
+ unset LANG LC_ALL
+ export LC_COLLATE="C"
+
+ use lua && lua-single_pkg_setup
+ use python && python-single-r1_pkg_setup
+}
+
+src_prepare() {
+ default
+
+ # Fixup a script to use awk instead of nawk
+ sed -i -e \
+ '1s|.*|#!'"${EPREFIX}"'/usr/bin/awk -f|' \
+ "${S}"/runtime/tools/mve.awk || die "mve.awk sed failed"
+
+ # Read vimrc and gvimrc from /etc/vim
+ echo '#define SYS_VIMRC_FILE "'${EPREFIX}'/etc/vim/vimrc"' \
+ >> "${S}"/src/feature.h || die "echo failed"
+ echo '#define SYS_GVIMRC_FILE "'${EPREFIX}'/etc/vim/gvimrc"' \
+ >> "${S}"/src/feature.h || die "echo failed"
+
+ # Use exuberant ctags which installs as /usr/bin/exuberant-ctags.
+ # Hopefully this pattern won't break for a while at least.
+ # This fixes bug 29398 (27 Sep 2003 agriffis)
+ sed -i -e \
+ 's/\<ctags\("\| [-*.]\)/exuberant-&/g' \
+ "${S}"/runtime/doc/syntax.txt \
+ "${S}"/runtime/doc/tagsrch.txt \
+ "${S}"/runtime/doc/usr_29.txt \
+ "${S}"/runtime/menu.vim \
+ "${S}"/src/configure.ac || die 'sed failed'
+
+ # gcc on sparc32 has this, uhm, interesting problem with detecting EOF
+ # correctly. To avoid some really entertaining error messages about stuff
+ # which isn't even in the source file being invalid, we'll do some trickery
+ # to make the error never occur. bug 66162 (02 October 2004 ciaranm)
+ find "${S}" -name '*.c' | while read c; do
+ echo >> "$c" || die "echo failed"
+ done
+
+ # Try to avoid sandbox problems. Bug #114475.
+ if [[ -d "${S}"/src/po ]]; then
+ sed -i -e \
+ '/-S check.vim/s,..VIM.,ln -s $(VIM) testvim \; ./testvim -X,' \
+ "${S}"/src/po/Makefile || die
+ fi
+
+ cp -v "${S}"/src/config.mk.dist "${S}"/src/auto/config.mk || die "cp failed"
+
+ # Fix bug 18245: Prevent "make" from the following chain:
+ # (1) Notice configure.ac is newer than auto/configure
+ # (2) Rebuild auto/configure
+ # (3) Notice auto/configure is newer than auto/config.mk
+ # (4) Run ./configure (with wrong args) to remake auto/config.mk
+ sed -i -e \
+ 's# auto/config\.mk:#:#' src/Makefile || die "Makefile sed failed"
+ rm -v src/auto/configure || die "rm failed"
+
+ # --with-features=huge forces on cscope even if we --disable it. We need
+ # to sed this out to avoid screwiness. (1 Sep 2004 ciaranm)
+ if ! use cscope; then
+ sed -i -e \
+ '/# define FEAT_CSCOPE/d' src/feature.h || die "couldn't disable cscope"
+ fi
+
+ # bug 908961
+ if use elibc_musl ; then
+ sed -i -e '/ja.sjis/d' src/po/Make_all.mak || die
+ fi
+}
+
+src_configure() {
+
+ # Fix bug 37354: Disallow -funroll-all-loops on amd64
+ # Bug 57859 suggests that we want to do this for all archs
+ filter-flags -funroll-all-loops
+
+ # Fix bug 76331: -O3 causes problems, use -O2 instead. We'll do this for
+ # everyone since previous flag filtering bugs have turned out to affect
+ # multiple archs...
+ replace-flags -O3 -O2
+
+ emake -j1 -C src autoconf
+
+ # This should fix a sandbox violation (see bug 24447). The hvc
+ # things are for ppc64, see bug 86433.
+ local file
+ for file in /dev/pty/s* /dev/console /dev/hvc/* /dev/hvc*; do
+ if [[ -e ${file} ]]; then
+ addwrite $file
+ fi
+ done
+
+ use debug && append-flags "-DDEBUG"
+
+ local myconf=(
+ --with-features=huge
+ --disable-gpm
+ --with-gnome=no
+ $(use_enable sound canberra)
+ $(use_enable acl)
+ $(use_enable crypt libsodium)
+ $(use_enable cscope)
+ $(use_enable netbeans)
+ $(use_enable nls)
+ $(use_enable perl perlinterp)
+ $(use_enable python python3interp)
+ $(use_with python python3-command "${PYTHON}")
+ $(use_enable racket mzschemeinterp)
+ $(use_enable ruby rubyinterp)
+ $(use_enable selinux)
+ $(use_enable session xsmp)
+ $(use_enable tcl tclinterp)
+ )
+
+ if use lua; then
+ # -DLUA_COMPAT_OPENLIB=1 is required to enable the
+ # deprecated (in 5.1) luaL_openlib API (#874690)
+ use lua_single_target_lua5-1 && append-cppflags -DLUA_COMPAT_OPENLIB=1
+
+ myconf+=(
+ --enable-luainterp
+ $(use_with lua_single_target_luajit luajit)
+ --with-lua-prefix="${EPREFIX}/usr"
+ )
+ fi
+
+ # Default is gtk unless aqua or motif are enabled
+ echo ; echo
+ if use aqua; then
+ einfo "Building gvim with the Carbon GUI"
+ myconf+=(
+ --enable-darwin
+ --enable-gui=carbon
+ )
+ elif use motif; then
+ einfo "Building gvim with the MOTIF GUI"
+ myconf+=( --enable-gui=motif )
+ else
+ myconf+=( --enable-gtk3-check )
+ einfo "Building gvim with the gtk+-3 GUI"
+ myconf+=( --enable-gui=gtk3 )
+ fi
+ echo ; echo
+
+ # let package manager strip binaries
+ export ac_cv_prog_STRIP="$(type -P true ) faking strip"
+
+ # keep prefix env contained within the EPREFIX
+ use prefix && myconf+=( --without-local-dir )
+
+ if tc-is-cross-compiler ; then
+ export vim_cv_getcwd_broken=no \
+ vim_cv_memmove_handles_overlap=yes \
+ vim_cv_stat_ignores_slash=yes \
+ vim_cv_terminfo=yes \
+ vim_cv_toupper_broken=no
+ fi
+
+ econf \
+ --with-modified-by="Gentoo-${PVR} (RIP Bram)" \
+ --with-vim-name=gvim \
+ --with-x \
+ "${myconf[@]}"
+}
+
+src_compile() {
+ # The following allows emake to be used
+ emake -j1 -C src auto/osdef.h objects
+
+ emake
+}
+
+src_test() {
+ einfo
+ einfo "Starting vim tests. Several error messages will be shown"
+ einfo "while the tests run. This is normal behaviour and does not"
+ einfo "indicate a fault."
+ einfo
+ ewarn "If the tests fail, your terminal may be left in a strange"
+ ewarn "state. Usually, running 'reset' will fix this."
+ einfo
+
+ # Don't let vim talk to X
+ unset DISPLAY
+
+ # Make gvim not try to connect to X. See :help gui-x11-start in vim for how
+ # this evil trickery works.
+ ln -s "${S}"/src/gvim "${S}"/src/testvim || die
+
+ # Make sure our VIMPROG is used.
+ sed -i -e 's:\.\./vim:../testvim:' src/testdir/test49.vim || die
+
+ # Don't do additional GUI tests.
+ emake -j1 VIMPROG=../testvim -C src/testdir nongui
+}
+
+# Call eselect vi update with --if-unset
+# to respect user's choice (bug 187449)
+eselect_vi_update() {
+ ebegin "Calling eselect vi update"
+ eselect vi update --if-unset
+ eend $?
+}
+
+src_install() {
+ local vimfiles=/usr/share/vim/vim${VIM_VERSION/.}
+
+ dobin src/gvim
+ dosym gvim /usr/bin/gvimdiff
+ dosym gvim /usr/bin/evim
+ dosym gvim /usr/bin/eview
+ dosym gvim /usr/bin/gview
+ dosym gvim /usr/bin/rgvim
+ dosym gvim /usr/bin/rgview
+
+ emake -C src DESTDIR="${D}" DATADIR="${EPREFIX}"/usr/share install-icons
+
+ dodir /usr/share/man/man1
+ echo ".so vim.1" > "${ED}"/usr/share/man/man1/gvim.1 || die "echo failed"
+ echo ".so vim.1" > "${ED}"/usr/share/man/man1/gview.1 || die "echo failed"
+ echo ".so vimdiff.1" > "${ED}"/usr/share/man/man1/gvimdiff.1 || \
+ die "echo failed"
+
+ insinto /etc/vim
+ newins "${FILESDIR}"/gvimrc-r1 gvimrc
+ eprefixify "${ED}"/etc/vim/gvimrc
+
+ # bash completion script, bug #79018.
+ newbashcomp "${FILESDIR}"/${PN}-completion ${PN}
+
+ # don't install vim desktop file
+ rm -v "${ED}"/usr/share/applications/vim.desktop || die "failed to remove vim.desktop"
+}
+
+pkg_postinst() {
+ # update documentation tags (from vim-doc.eclass)
+ update_vim_helptags
+
+ # update fdo mime stuff, bug #78394
+ xdg_desktop_database_update
+
+ # update icon cache
+ xdg_icon_cache_update
+
+ # call eselect vi update
+ eselect_vi_update
+}
+
+pkg_postrm() {
+ # update documentation tags (from vim-doc.eclass)
+ update_vim_helptags
+
+ # update fdo mime stuff, bug #78394
+ xdg_desktop_database_update
+
+ # update icon cache
+ xdg_icon_cache_update
+
+ # call eselect vi update
+ eselect_vi_update
+}
diff --git a/app-editors/gvim/gvim-9.1.0470.ebuild b/app-editors/gvim/gvim-9.1.0470.ebuild
new file mode 100644
index 000000000000..826999e81017
--- /dev/null
+++ b/app-editors/gvim/gvim-9.1.0470.ebuild
@@ -0,0 +1,365 @@
+# Copyright 1999-2024 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+# Please bump with app-editors/vim-core and app-editors/vim
+
+VIM_VERSION="9.1"
+VIM_PATCHES_VERSION="9.0.2092"
+
+LUA_COMPAT=( lua5-{1..4} luajit )
+PYTHON_COMPAT=( python3_{10..12} )
+PYTHON_REQ_USE="threads(+)"
+USE_RUBY="ruby31 ruby32"
+
+inherit bash-completion-r1 flag-o-matic lua-single prefix python-single-r1 ruby-single toolchain-funcs vim-doc xdg-utils
+
+if [[ ${PV} == 9999* ]]; then
+ inherit git-r3
+ EGIT_REPO_URI="https://github.com/vim/vim.git"
+ EGIT_CHECKOUT_DIR=${WORKDIR}/vim-${PV}
+else
+ SRC_URI="https://github.com/vim/vim/archive/v${PV}.tar.gz -> vim-${PV}.tar.gz
+ https://git.sr.ht/~xxc3nsoredxx/vim-patches/refs/download/vim-${VIM_PATCHES_VERSION}-patches/vim-${VIM_PATCHES_VERSION}-patches.tar.xz"
+ KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~ia64 ~ppc ~ppc64 ~riscv ~s390 ~sparc ~x86 ~amd64-linux ~x86-linux ~ppc-macos"
+fi
+S="${WORKDIR}"/vim-${PV}
+
+DESCRIPTION="GUI version of the Vim text editor"
+HOMEPAGE="https://www.vim.org https://github.com/vim/vim"
+
+LICENSE="vim"
+SLOT="0"
+IUSE="acl aqua crypt cscope debug lua minimal motif netbeans nls perl python racket ruby selinux session sound tcl"
+REQUIRED_USE="
+ lua? ( ${LUA_REQUIRED_USE} )
+ python? ( ${PYTHON_REQUIRED_USE} )
+ aqua? ( !motif )
+"
+
+RDEPEND="
+ ~app-editors/vim-core-${PV}
+ >=app-eselect/eselect-vi-1.1
+ >=sys-libs/ncurses-5.2-r2:0=
+ x11-libs/libICE
+ x11-libs/libSM
+ x11-libs/libXext
+ x11-libs/libXt
+ acl? ( kernel_linux? ( sys-apps/acl ) )
+ !aqua? (
+ motif? ( >=x11-libs/motif-2.3:0 )
+ !motif? (
+ x11-libs/gtk+:3
+ x11-libs/libXft
+ )
+ )
+ crypt? ( dev-libs/libsodium:= )
+ cscope? ( dev-util/cscope )
+ lua? (
+ ${LUA_DEPS}
+ $(lua_gen_impl_dep 'deprecated' lua5-1)
+ )
+ nls? ( virtual/libintl )
+ perl? ( dev-lang/perl:= )
+ python? ( ${PYTHON_DEPS} )
+ racket? ( dev-scheme/racket )
+ ruby? ( ${RUBY_DEPS} )
+ selinux? ( sys-libs/libselinux )
+ session? ( x11-libs/libSM )
+ sound? ( media-libs/libcanberra )
+ tcl? ( dev-lang/tcl:0= )
+"
+DEPEND="${RDEPEND}
+ x11-base/xorg-proto"
+# configure runs the Lua interpreter
+BDEPEND="
+ dev-build/autoconf
+ virtual/pkgconfig
+ lua? ( ${LUA_DEPS} )
+ nls? ( sys-devel/gettext )
+"
+PDEPEND="!minimal? ( app-vim/gentoo-syntax )"
+
+if [[ ${PV} != 9999* ]]; then
+ # Gentoo patches to fix runtime issues, cross-compile errors, etc
+ PATCHES=(
+ "${WORKDIR}/vim-${VIM_PATCHES_VERSION}-patches"
+ )
+fi
+
+# various failures (bugs #630042 and #682320)
+RESTRICT="test"
+
+# platform-specific checks (bug #898450):
+# - acl() -- Solaris
+# - statacl() -- AIX
+QA_CONFIG_IMPL_DECL_SKIP=(
+ 'acl'
+ 'statacl'
+)
+
+pkg_setup() {
+ # people with broken alphabets run into trouble. bug 82186.
+ unset LANG LC_ALL
+ export LC_COLLATE="C"
+
+ use lua && lua-single_pkg_setup
+ use python && python-single-r1_pkg_setup
+}
+
+src_prepare() {
+ default
+
+ # Fixup a script to use awk instead of nawk
+ sed -i -e \
+ '1s|.*|#!'"${EPREFIX}"'/usr/bin/awk -f|' \
+ "${S}"/runtime/tools/mve.awk || die "mve.awk sed failed"
+
+ # Read vimrc and gvimrc from /etc/vim
+ echo '#define SYS_VIMRC_FILE "'${EPREFIX}'/etc/vim/vimrc"' \
+ >> "${S}"/src/feature.h || die "echo failed"
+ echo '#define SYS_GVIMRC_FILE "'${EPREFIX}'/etc/vim/gvimrc"' \
+ >> "${S}"/src/feature.h || die "echo failed"
+
+ # Use exuberant ctags which installs as /usr/bin/exuberant-ctags.
+ # Hopefully this pattern won't break for a while at least.
+ # This fixes bug 29398 (27 Sep 2003 agriffis)
+ sed -i -e \
+ 's/\<ctags\("\| [-*.]\)/exuberant-&/g' \
+ "${S}"/runtime/doc/syntax.txt \
+ "${S}"/runtime/doc/tagsrch.txt \
+ "${S}"/runtime/doc/usr_29.txt \
+ "${S}"/runtime/menu.vim \
+ "${S}"/src/configure.ac || die 'sed failed'
+
+ # gcc on sparc32 has this, uhm, interesting problem with detecting EOF
+ # correctly. To avoid some really entertaining error messages about stuff
+ # which isn't even in the source file being invalid, we'll do some trickery
+ # to make the error never occur. bug 66162 (02 October 2004 ciaranm)
+ find "${S}" -name '*.c' | while read c; do
+ echo >> "$c" || die "echo failed"
+ done
+
+ # Try to avoid sandbox problems. Bug #114475.
+ if [[ -d "${S}"/src/po ]]; then
+ sed -i -e \
+ '/-S check.vim/s,..VIM.,ln -s $(VIM) testvim \; ./testvim -X,' \
+ "${S}"/src/po/Makefile || die
+ fi
+
+ cp -v "${S}"/src/config.mk.dist "${S}"/src/auto/config.mk || die "cp failed"
+
+ # Fix bug 18245: Prevent "make" from the following chain:
+ # (1) Notice configure.ac is newer than auto/configure
+ # (2) Rebuild auto/configure
+ # (3) Notice auto/configure is newer than auto/config.mk
+ # (4) Run ./configure (with wrong args) to remake auto/config.mk
+ sed -i -e \
+ 's# auto/config\.mk:#:#' src/Makefile || die "Makefile sed failed"
+ rm -v src/auto/configure || die "rm failed"
+
+ # --with-features=huge forces on cscope even if we --disable it. We need
+ # to sed this out to avoid screwiness. (1 Sep 2004 ciaranm)
+ if ! use cscope; then
+ sed -i -e \
+ '/# define FEAT_CSCOPE/d' src/feature.h || die "couldn't disable cscope"
+ fi
+
+ # bug 908961
+ if use elibc_musl ; then
+ sed -i -e '/ja.sjis/d' src/po/Make_all.mak || die
+ fi
+}
+
+src_configure() {
+
+ # Fix bug 37354: Disallow -funroll-all-loops on amd64
+ # Bug 57859 suggests that we want to do this for all archs
+ filter-flags -funroll-all-loops
+
+ # Fix bug 76331: -O3 causes problems, use -O2 instead. We'll do this for
+ # everyone since previous flag filtering bugs have turned out to affect
+ # multiple archs...
+ replace-flags -O3 -O2
+
+ emake -j1 -C src autoconf
+
+ # This should fix a sandbox violation (see bug 24447). The hvc
+ # things are for ppc64, see bug 86433.
+ local file
+ for file in /dev/pty/s* /dev/console /dev/hvc/* /dev/hvc*; do
+ if [[ -e ${file} ]]; then
+ addwrite $file
+ fi
+ done
+
+ use debug && append-flags "-DDEBUG"
+
+ local myconf=(
+ --with-features=huge
+ --disable-gpm
+ --with-gnome=no
+ $(use_enable sound canberra)
+ $(use_enable acl)
+ $(use_enable crypt libsodium)
+ $(use_enable cscope)
+ $(use_enable netbeans)
+ $(use_enable nls)
+ $(use_enable perl perlinterp)
+ $(use_enable python python3interp)
+ $(use_with python python3-command "${PYTHON}")
+ $(use_enable racket mzschemeinterp)
+ $(use_enable ruby rubyinterp)
+ $(use_enable selinux)
+ $(use_enable session xsmp)
+ $(use_enable tcl tclinterp)
+ )
+
+ if use lua; then
+ # -DLUA_COMPAT_OPENLIB=1 is required to enable the
+ # deprecated (in 5.1) luaL_openlib API (#874690)
+ use lua_single_target_lua5-1 && append-cppflags -DLUA_COMPAT_OPENLIB=1
+
+ myconf+=(
+ --enable-luainterp
+ $(use_with lua_single_target_luajit luajit)
+ --with-lua-prefix="${EPREFIX}/usr"
+ )
+ fi
+
+ # Default is gtk unless aqua or motif are enabled
+ echo ; echo
+ if use aqua; then
+ einfo "Building gvim with the Carbon GUI"
+ myconf+=(
+ --enable-darwin
+ --enable-gui=carbon
+ )
+ elif use motif; then
+ einfo "Building gvim with the MOTIF GUI"
+ myconf+=( --enable-gui=motif )
+ else
+ myconf+=( --enable-gtk3-check )
+ einfo "Building gvim with the gtk+-3 GUI"
+ myconf+=( --enable-gui=gtk3 )
+ fi
+ echo ; echo
+
+ # let package manager strip binaries
+ export ac_cv_prog_STRIP="$(type -P true ) faking strip"
+
+ # keep prefix env contained within the EPREFIX
+ use prefix && myconf+=( --without-local-dir )
+
+ if tc-is-cross-compiler ; then
+ export vim_cv_getcwd_broken=no \
+ vim_cv_memmove_handles_overlap=yes \
+ vim_cv_stat_ignores_slash=yes \
+ vim_cv_terminfo=yes \
+ vim_cv_toupper_broken=no
+ fi
+
+ econf \
+ --with-modified-by="Gentoo-${PVR} (RIP Bram)" \
+ --with-vim-name=gvim \
+ --with-x \
+ "${myconf[@]}"
+}
+
+src_compile() {
+ # The following allows emake to be used
+ emake -j1 -C src auto/osdef.h objects
+
+ emake
+}
+
+src_test() {
+ einfo
+ einfo "Starting vim tests. Several error messages will be shown"
+ einfo "while the tests run. This is normal behaviour and does not"
+ einfo "indicate a fault."
+ einfo
+ ewarn "If the tests fail, your terminal may be left in a strange"
+ ewarn "state. Usually, running 'reset' will fix this."
+ einfo
+
+ # Don't let vim talk to X
+ unset DISPLAY
+
+ # Make gvim not try to connect to X. See :help gui-x11-start in vim for how
+ # this evil trickery works.
+ ln -s "${S}"/src/gvim "${S}"/src/testvim || die
+
+ # Make sure our VIMPROG is used.
+ sed -i -e 's:\.\./vim:../testvim:' src/testdir/test49.vim || die
+
+ # Don't do additional GUI tests.
+ emake -j1 VIMPROG=../testvim -C src/testdir nongui
+}
+
+# Call eselect vi update with --if-unset
+# to respect user's choice (bug 187449)
+eselect_vi_update() {
+ ebegin "Calling eselect vi update"
+ eselect vi update --if-unset
+ eend $?
+}
+
+src_install() {
+ local vimfiles=/usr/share/vim/vim${VIM_VERSION/.}
+
+ dobin src/gvim
+ dosym gvim /usr/bin/gvimdiff
+ dosym gvim /usr/bin/evim
+ dosym gvim /usr/bin/eview
+ dosym gvim /usr/bin/gview
+ dosym gvim /usr/bin/rgvim
+ dosym gvim /usr/bin/rgview
+
+ emake -C src DESTDIR="${D}" DATADIR="${EPREFIX}"/usr/share install-icons
+
+ dodir /usr/share/man/man1
+ echo ".so vim.1" > "${ED}"/usr/share/man/man1/gvim.1 || die "echo failed"
+ echo ".so vim.1" > "${ED}"/usr/share/man/man1/gview.1 || die "echo failed"
+ echo ".so vimdiff.1" > "${ED}"/usr/share/man/man1/gvimdiff.1 || \
+ die "echo failed"
+
+ insinto /etc/vim
+ newins "${FILESDIR}"/gvimrc-r1 gvimrc
+ eprefixify "${ED}"/etc/vim/gvimrc
+
+ # bash completion script, bug #79018.
+ newbashcomp "${FILESDIR}"/${PN}-completion ${PN}
+
+ # don't install vim desktop file
+ rm -v "${ED}"/usr/share/applications/vim.desktop || die "failed to remove vim.desktop"
+}
+
+pkg_postinst() {
+ # update documentation tags (from vim-doc.eclass)
+ update_vim_helptags
+
+ # update fdo mime stuff, bug #78394
+ xdg_desktop_database_update
+
+ # update icon cache
+ xdg_icon_cache_update
+
+ # call eselect vi update
+ eselect_vi_update
+}
+
+pkg_postrm() {
+ # update documentation tags (from vim-doc.eclass)
+ update_vim_helptags
+
+ # update fdo mime stuff, bug #78394
+ xdg_desktop_database_update
+
+ # update icon cache
+ xdg_icon_cache_update
+
+ # call eselect vi update
+ eselect_vi_update
+}
diff --git a/app-editors/gvim/gvim-9999.ebuild b/app-editors/gvim/gvim-9999.ebuild
index ecd0b5e0dd0f..826999e81017 100644
--- a/app-editors/gvim/gvim-9999.ebuild
+++ b/app-editors/gvim/gvim-9999.ebuild
@@ -1,14 +1,19 @@
-# Copyright 1999-2021 Gentoo Authors
+# Copyright 1999-2024 Gentoo Authors
# Distributed under the terms of the GNU General Public License v2
-EAPI=7
-VIM_VERSION="8.2"
-LUA_COMPAT=( lua5-1 luajit )
-PYTHON_COMPAT=( python3_{7..10} )
+EAPI=8
+
+# Please bump with app-editors/vim-core and app-editors/vim
+
+VIM_VERSION="9.1"
+VIM_PATCHES_VERSION="9.0.2092"
+
+LUA_COMPAT=( lua5-{1..4} luajit )
+PYTHON_COMPAT=( python3_{10..12} )
PYTHON_REQ_USE="threads(+)"
-USE_RUBY="ruby24 ruby25 ruby26 ruby27"
+USE_RUBY="ruby31 ruby32"
-inherit vim-doc flag-o-matic xdg-utils bash-completion-r1 prefix lua-single python-single-r1 ruby-single
+inherit bash-completion-r1 flag-o-matic lua-single prefix python-single-r1 ruby-single toolchain-funcs vim-doc xdg-utils
if [[ ${PV} == 9999* ]]; then
inherit git-r3
@@ -16,19 +21,21 @@ if [[ ${PV} == 9999* ]]; then
EGIT_CHECKOUT_DIR=${WORKDIR}/vim-${PV}
else
SRC_URI="https://github.com/vim/vim/archive/v${PV}.tar.gz -> vim-${PV}.tar.gz
- https://dev.gentoo.org/~zlogene/distfiles/app-editors/vim/vim-8.2.0360-gentoo-patches.tar.xz"
- KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~ia64 ~ppc ~ppc64 ~sparc ~x86 ~amd64-linux ~x86-linux ~ppc-macos ~x86-solaris"
+ https://git.sr.ht/~xxc3nsoredxx/vim-patches/refs/download/vim-${VIM_PATCHES_VERSION}-patches/vim-${VIM_PATCHES_VERSION}-patches.tar.xz"
+ KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~ia64 ~ppc ~ppc64 ~riscv ~s390 ~sparc ~x86 ~amd64-linux ~x86-linux ~ppc-macos"
fi
+S="${WORKDIR}"/vim-${PV}
DESCRIPTION="GUI version of the Vim text editor"
-HOMEPAGE="https://vim.sourceforge.io/ https://github.com/vim/vim"
+HOMEPAGE="https://www.vim.org https://github.com/vim/vim"
-SLOT="0"
LICENSE="vim"
-IUSE="acl aqua cscope debug gtk gtk2 lua motif neXt netbeans nls perl python racket ruby selinux session sound tcl"
+SLOT="0"
+IUSE="acl aqua crypt cscope debug lua minimal motif netbeans nls perl python racket ruby selinux session sound tcl"
REQUIRED_USE="
lua? ( ${LUA_REQUIRED_USE} )
python? ( ${PYTHON_REQUIRED_USE} )
+ aqua? ( !motif )
"
RDEPEND="
@@ -41,24 +48,13 @@ RDEPEND="
x11-libs/libXt
acl? ( kernel_linux? ( sys-apps/acl ) )
!aqua? (
- gtk? (
+ motif? ( >=x11-libs/motif-2.3:0 )
+ !motif? (
x11-libs/gtk+:3
x11-libs/libXft
)
- !gtk? (
- gtk2? (
- >=x11-libs/gtk+-2.6:2
- x11-libs/libXft
- )
- !gtk2? (
- motif? ( >=x11-libs/motif-2.3:0 )
- !motif? (
- neXt? ( x11-libs/neXtaw )
- !neXt? ( x11-libs/libXaw )
- )
- )
- )
)
+ crypt? ( dev-libs/libsodium:= )
cscope? ( dev-util/cscope )
lua? (
${LUA_DEPS}
@@ -75,36 +71,45 @@ RDEPEND="
tcl? ( dev-lang/tcl:0= )
"
DEPEND="${RDEPEND}
- sys-devel/autoconf
+ x11-base/xorg-proto"
+# configure runs the Lua interpreter
+BDEPEND="
+ dev-build/autoconf
virtual/pkgconfig
+ lua? ( ${LUA_DEPS} )
nls? ( sys-devel/gettext )
"
-# configure runs the Lua interpreter
-BDEPEND="lua? ( ${LUA_DEPS} )"
+PDEPEND="!minimal? ( app-vim/gentoo-syntax )"
+
+if [[ ${PV} != 9999* ]]; then
+ # Gentoo patches to fix runtime issues, cross-compile errors, etc
+ PATCHES=(
+ "${WORKDIR}/vim-${VIM_PATCHES_VERSION}-patches"
+ )
+fi
# various failures (bugs #630042 and #682320)
RESTRICT="test"
-S=${WORKDIR}/vim-${PV}
+# platform-specific checks (bug #898450):
+# - acl() -- Solaris
+# - statacl() -- AIX
+QA_CONFIG_IMPL_DECL_SKIP=(
+ 'acl'
+ 'statacl'
+)
pkg_setup() {
# people with broken alphabets run into trouble. bug 82186.
unset LANG LC_ALL
export LC_COLLATE="C"
- # Gnome sandbox silliness. bug #114475.
- mkdir -p "${T}"/home || die
- export HOME="${T}"/home
-
use lua && lua-single_pkg_setup
use python && python-single-r1_pkg_setup
}
src_prepare() {
- if [[ ${PV} != 9999* ]]; then
- # Gentoo patches to fix runtime issues, cross-compile errors, etc
- eapply "${WORKDIR}"/patches/
- fi
+ default
# Fixup a script to use awk instead of nawk
sed -i -e \
@@ -113,9 +118,9 @@ src_prepare() {
# Read vimrc and gvimrc from /etc/vim
echo '#define SYS_VIMRC_FILE "'${EPREFIX}'/etc/vim/vimrc"' \
- >> "${S}"/src/feature.h || die "echo failed"
+ >> "${S}"/src/feature.h || die "echo failed"
echo '#define SYS_GVIMRC_FILE "'${EPREFIX}'/etc/vim/gvimrc"' \
- >> "${S}"/src/feature.h || die "echo failed"
+ >> "${S}"/src/feature.h || die "echo failed"
# Use exuberant ctags which installs as /usr/bin/exuberant-ctags.
# Hopefully this pattern won't break for a while at least.
@@ -128,18 +133,12 @@ src_prepare() {
"${S}"/runtime/menu.vim \
"${S}"/src/configure.ac || die 'sed failed'
- # Don't be fooled by /usr/include/libc.h. When found, vim thinks
- # this is NeXT, but it's actually just a file in dev-libs/9libs
- # This fixes bug 43885 (20 Mar 2004 agriffis)
- sed -i -e \
- 's/ libc\.h / /' "${S}"/src/configure.ac || die 'sed failed'
-
# gcc on sparc32 has this, uhm, interesting problem with detecting EOF
# correctly. To avoid some really entertaining error messages about stuff
# which isn't even in the source file being invalid, we'll do some trickery
# to make the error never occur. bug 66162 (02 October 2004 ciaranm)
find "${S}" -name '*.c' | while read c; do
- echo >> "$c" || die "echo failed"
+ echo >> "$c" || die "echo failed"
done
# Try to avoid sandbox problems. Bug #114475.
@@ -151,16 +150,29 @@ src_prepare() {
cp -v "${S}"/src/config.mk.dist "${S}"/src/auto/config.mk || die "cp failed"
- # Bug #378107 - Build properly with >=perl-core/ExtUtils-ParseXS-3.20.0
+ # Fix bug 18245: Prevent "make" from the following chain:
+ # (1) Notice configure.ac is newer than auto/configure
+ # (2) Rebuild auto/configure
+ # (3) Notice auto/configure is newer than auto/config.mk
+ # (4) Run ./configure (with wrong args) to remake auto/config.mk
sed -i -e \
- "s:\\\$(PERLLIB)/ExtUtils/xsubpp:${EPREFIX}/usr/bin/xsubpp:" \
- "${S}"/src/Makefile || die 'sed for ExtUtils-ParseXS failed'
+ 's# auto/config\.mk:#:#' src/Makefile || die "Makefile sed failed"
+ rm -v src/auto/configure || die "rm failed"
+
+ # --with-features=huge forces on cscope even if we --disable it. We need
+ # to sed this out to avoid screwiness. (1 Sep 2004 ciaranm)
+ if ! use cscope; then
+ sed -i -e \
+ '/# define FEAT_CSCOPE/d' src/feature.h || die "couldn't disable cscope"
+ fi
- eapply_user
+ # bug 908961
+ if use elibc_musl ; then
+ sed -i -e '/ja.sjis/d' src/po/Make_all.mak || die
+ fi
}
src_configure() {
- local myconf=()
# Fix bug 37354: Disallow -funroll-all-loops on amd64
# Bug 57859 suggests that we want to do this for all archs
@@ -171,14 +183,6 @@ src_configure() {
# multiple archs...
replace-flags -O3 -O2
- # Fix bug 18245: Prevent "make" from the following chain:
- # (1) Notice configure.ac is newer than auto/configure
- # (2) Rebuild auto/configure
- # (3) Notice auto/configure is newer than auto/config.mk
- # (4) Run ./configure (with wrong args) to remake auto/config.mk
- sed -i -e \
- 's# auto/config\.mk:#:#' src/Makefile || die "Makefile sed failed"
- rm -v src/auto/configure || die "rm failed"
emake -j1 -C src autoconf
# This should fix a sandbox violation (see bug 24447). The hvc
@@ -192,12 +196,13 @@ src_configure() {
use debug && append-flags "-DDEBUG"
- myconf=(
+ local myconf=(
--with-features=huge
--disable-gpm
--with-gnome=no
$(use_enable sound canberra)
$(use_enable acl)
+ $(use_enable crypt libsodium)
$(use_enable cscope)
$(use_enable netbeans)
$(use_enable nls)
@@ -211,14 +216,11 @@ src_configure() {
$(use_enable tcl tclinterp)
)
- # --with-features=huge forces on cscope even if we --disable it. We need
- # to sed this out to avoid screwiness. (1 Sep 2004 ciaranm)
- if ! use cscope; then
- sed -i -e \
- '/# define FEAT_CSCOPE/d' src/feature.h || die "couldn't disable cscope"
- fi
-
if use lua; then
+ # -DLUA_COMPAT_OPENLIB=1 is required to enable the
+ # deprecated (in 5.1) luaL_openlib API (#874690)
+ use lua_single_target_lua5-1 && append-cppflags -DLUA_COMPAT_OPENLIB=1
+
myconf+=(
--enable-luainterp
$(use_with lua_single_target_luajit luajit)
@@ -226,13 +228,7 @@ src_configure() {
)
fi
- # gvim's GUI preference order is as follows:
- # aqua CARBON (not tested)
- # -aqua gtk GTK3
- # -aqua -gtk gtk2 GTK2
- # -aqua -gtk -gtk motif MOTIF
- # -aqua -gtk -gtk -motif neXt NEXTAW
- # -aqua -gtk -gtk -motif -neXt ATHENA
+ # Default is gtk unless aqua or motif are enabled
echo ; echo
if use aqua; then
einfo "Building gvim with the Carbon GUI"
@@ -240,23 +236,13 @@ src_configure() {
--enable-darwin
--enable-gui=carbon
)
- elif use gtk; then
- myconf+=( --enable-gtk3-check )
- einfo "Building gvim with the gtk+-3 GUI"
- myconf+=( --enable-gui=gtk3 )
- elif use gtk2; then
- myconf+=( --enable-gtk2-check )
- einfo "Building gvim with the gtk+-2 GUI"
- myconf+=( --enable-gui=gtk2 )
elif use motif; then
einfo "Building gvim with the MOTIF GUI"
myconf+=( --enable-gui=motif )
- elif use neXt; then
- einfo "Building gvim with the neXtaw GUI"
- myconf+=( --enable-gui=nextaw )
else
- einfo "Building gvim with the Athena GUI"
- myconf+=( --enable-gui=athena )
+ myconf+=( --enable-gtk3-check )
+ einfo "Building gvim with the gtk+-3 GUI"
+ myconf+=( --enable-gui=gtk3 )
fi
echo ; echo
@@ -266,15 +252,16 @@ src_configure() {
# keep prefix env contained within the EPREFIX
use prefix && myconf+=( --without-local-dir )
- if [[ ${CHOST} == *-interix* ]]; then
- # avoid finding of this function, to avoid having to patch either
- # configure or the source, which would be much more hackish.
- # after all vim does it right, only interix is badly broken (again)
- export ac_cv_func_sigaction=no
+ if tc-is-cross-compiler ; then
+ export vim_cv_getcwd_broken=no \
+ vim_cv_memmove_handles_overlap=yes \
+ vim_cv_stat_ignores_slash=yes \
+ vim_cv_terminfo=yes \
+ vim_cv_toupper_broken=no
fi
econf \
- --with-modified-by=Gentoo-${PVR} \
+ --with-modified-by="Gentoo-${PVR} (RIP Bram)" \
--with-vim-name=gvim \
--with-x \
"${myconf[@]}"
@@ -314,7 +301,7 @@ src_test() {
# Call eselect vi update with --if-unset
# to respect user's choice (bug 187449)
eselect_vi_update() {
- einfo "Calling eselect vi update..."
+ ebegin "Calling eselect vi update"
eselect vi update --if-unset
eend $?
}
diff --git a/app-editors/gvim/metadata.xml b/app-editors/gvim/metadata.xml
index be92dc54342a..7a9a9815c21b 100644
--- a/app-editors/gvim/metadata.xml
+++ b/app-editors/gvim/metadata.xml
@@ -1,13 +1,21 @@
<?xml version="1.0" encoding="UTF-8"?>
-<!DOCTYPE pkgmetadata SYSTEM "http://www.gentoo.org/dtd/metadata.dtd">
+<!DOCTYPE pkgmetadata SYSTEM "https://www.gentoo.org/dtd/metadata.dtd">
<pkgmetadata>
+ <maintainer type="person" proxied="yes">
+ <email>xxc3ncoredxx@gmail.com</email>
+ <name>Oskari Pirhonen</name>
+ </maintainer>
<maintainer type="project">
<email>vim@gentoo.org</email>
<name>Gentoo Vim Project</name>
</maintainer>
+ <maintainer type="project" proxied="proxy">
+ <email>proxy-maint@gentoo.org</email>
+ <name>Proxy Maintainers</name>
+ </maintainer>
<use>
+ <flag name="crypt">Use <pkg>dev-libs/libsodium</pkg> for crypto support</flag>
<flag name="cscope">Enable cscope interface</flag>
- <flag name="gtk2">Enable GTK+2 interface</flag>
<flag name="netbeans">Include netbeans external editor integration support</flag>
<flag name="racket">Enable support for Scheme using <pkg>dev-scheme/racket</pkg></flag>
</use>